Commit 2d099cca authored by Namhyung Kim's avatar Namhyung Kim Committed by Arnaldo Carvalho de Melo
Browse files

perf test: Add perf trace summary test



  $ sudo ./perf test -vv 'trace summary'
  109: perf trace summary:
  --- start ---
  test child forked, pid 3501572
  testing: perf trace -s -- true
  testing: perf trace -S -- true
  testing: perf trace -s --summary-mode=thread -- true
  testing: perf trace -S --summary-mode=total -- true
  testing: perf trace -as --summary-mode=thread --no-bpf-summary -- true
  testing: perf trace -as --summary-mode=total --no-bpf-summary -- true
  testing: perf trace -as --summary-mode=thread --bpf-summary -- true
  testing: perf trace -as --summary-mode=total --bpf-summary -- true
  testing: perf trace -aS --summary-mode=total --bpf-summary -- true
  ---- end(0) ----
  109: perf trace summary                                              : Ok

Reviewed-by: default avatarHoward Chu <howardchu95@gmail.com>
Signed-off-by: default avatarNamhyung Kim <namhyung@kernel.org>
Tested-by: default avatarArnaldo Carvalho de Melo <acme@redhat.com>
Cc: Adrian Hunter <adrian.hunter@intel.com>
Cc: Howard Chu <howardchu95@gmail.com>
Cc: Ian Rogers <irogers@google.com>
Cc: Ingo Molnar <mingo@kernel.org>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Kan Liang <kan.liang@linux.intel.com>
Cc: Peter Zijlstra <peterz@infradead.org>
Cc: Song Liu <song@kernel.org>
Cc: bpf@vger.kernel.org
Link: https://lore.kernel.org/r/20250326044001.3503432-2-namhyung@kernel.org


Signed-off-by: default avatarArnaldo Carvalho de Melo <acme@redhat.com>
parent 1bec43f5
Loading
Loading
Loading
Loading
+65 −0
Original line number Diff line number Diff line
#!/bin/sh
# perf trace summary
# SPDX-License-Identifier: GPL-2.0

# Check that perf trace works with various summary mode

# shellcheck source=lib/probe.sh
. "$(dirname $0)"/lib/probe.sh

skip_if_no_perf_trace || exit 2
[ "$(id -u)" = 0 ] || exit 2

OUTPUT=$(mktemp /tmp/perf_trace_test.XXXXX)

test_perf_trace() {
    args=$1
    workload="true"
    search="^\s*(open|read|close).*[0-9]+%$"

    echo "testing: perf trace ${args} -- ${workload}"
    perf trace ${args} -- ${workload} >${OUTPUT} 2>&1
    if [ $? -ne 0 ]; then
        echo "Error: perf trace ${args} failed unexpectedly"
        cat ${OUTPUT}
        rm -f ${OUTPUT}
        exit 1
    fi

    count=$(grep -E -c -m 3 "${search}" ${OUTPUT})
    if [ "${count}" != "3" ]; then
	echo "Error: cannot find enough pattern ${search} in the output"
	cat ${OUTPUT}
	rm -f ${OUTPUT}
	exit 1
    fi
}

# summary only for a process
test_perf_trace "-s"

# normal output with summary at the end
test_perf_trace "-S"

# summary only with an explicit summary mode
test_perf_trace "-s --summary-mode=thread"

# summary with normal output - total summary mode
test_perf_trace "-S --summary-mode=total"

# summary only for system wide - per-thread summary
test_perf_trace "-as --summary-mode=thread --no-bpf-summary"

# summary only for system wide - total summary mode
test_perf_trace "-as --summary-mode=total --no-bpf-summary"

# summary only for system wide - per-thread summary with BPF
test_perf_trace "-as --summary-mode=thread --bpf-summary"

# summary only for system wide - total summary mode with BPF
test_perf_trace "-as --summary-mode=total --bpf-summary"

# summary with normal output for system wide - total summary mode with BPF
test_perf_trace "-aS --summary-mode=total --bpf-summary"

rm -f ${OUTPUT}